VERSION 5.00
Begin VB.Form Form2 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Open Image"
   ClientHeight    =   4995
   ClientLeft      =   150
   ClientTop       =   435
   ClientWidth     =   8685
   ClipControls    =   0   'False
   Icon            =   "frmOpen.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form2"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4995
   ScaleWidth      =   8685
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdGo 
      Caption         =   "&Go"
      Height          =   375
      Left            =   5400
      TabIndex        =   6
      Top             =   3720
      Width           =   495
   End
   Begin VB.TextBox txtPath 
      Height          =   405
      Left            =   120
      TabIndex        =   0
      Top             =   3720
      Width           =   5055
   End
   Begin VB.CommandButton cmdOk 
      Caption         =   "&OK"
      Default         =   -1  'True
      Height          =   495
      Left            =   4800
      TabIndex        =   5
      Top             =   4320
      Width           =   3735
   End
   Begin VB.DriveListBox Drive1 
      Height          =   315
      Left            =   120
      TabIndex        =   4
      Top             =   3240
      Width           =   2895
   End
   Begin VB.DirListBox Dir1 
      Height          =   3015
      Left            =   120
      TabIndex        =   3
      Top             =   120
      Width           =   2895
   End
   Begin VB.FileListBox File1 
      Height          =   3405
      Hidden          =   -1  'True
      Left            =   3240
      Pattern         =   "*.bmp;*.gif;*.jpg;*.wmf"
      System          =   -1  'True
      TabIndex        =   2
      Top             =   120
      Width           =   2895
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   4320
      Width           =   3855
   End
   Begin VB.Image imgBlank 
      Height          =   495
      Left            =   10080
      Top             =   6600
      Visible         =   0   'False
      Width           =   1215
   End
   Begin VB.Image Image2 
      Height          =   2535
      Left            =   6360
      Stretch         =   -1  'True
      Top             =   120
      Width           =   2175
   End
   Begin VB.Image Image1 
      Height          =   4320
      Left            =   120
      Picture         =   "frmOpen.frx":030A
      Top             =   4440
      Visible         =   0   'False
      Width           =   5370
   End
End
Attribute VB_Name = "Form2"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Compare Text
Dim p As Integer

Private Sub cmdCancel_Click()
'Cancel was pressed. Unload the Image Loader Form
    Me.Visible = False
End Sub

Private Sub cmdOK_Click()
'    On Error Resume Next
'YY:
'Ok was pressed. Set the puzzle new image
    Dim S As String
'Get the file's path and check if it already has a "\"
'If not then add one "\"
    If File1.FileName = "" Then
        MsgBox "Please select an image", vbApplicationModal + _
            vbExclamation + vbOKOnly, "Error"
        GoTo y
    End If
    S = File1.Path
    If Not S Like "*\" Then S = S & "\"
'Now add the file name
    S = S & File1.FileName
'Unload the Image Loader Form
    Me.Visible = False
'Load the puzzle new image
    Image1.Picture = LoadPicture(S)
'Hide the pieces and start again
    HideAll
    Start
    txtPath.Text = ""
'    File1.SetFocus
y::
    Form1.Caption = "Solve the Puzzle" + "   " + File1.FileName

End Sub

Private Sub cmdGo_Click()
    On Error Resume Next
    Dim y As String
PP:
'set text as directory
    Dir1.Path = txtPath.Text
    y = Left(txtPath.Text, 3)
    Drive1.Drive = y
'Error 68 ocurrs when there is an error with access to
'the Drive
    If Err.Number = 68 Then
        Err.Clear
'Check if the user want's to retry
        MsgBox "The drive " & y & " is not ready! Try again?", _
            vbApplicationModal + vbExclamation + vbYesNo, "Error"
'Else set the Drive to the default C: drive
        Drive1.Drive = "C:\"
    End If
    
'check for valid path
'Error 76 occurs when path is invalid or nonexistent
    If Err.Number = 76 Then
        Err.Clear
        If MsgBox("Invalid Path", vbApplicationModal + vbExclamation _
            + vbOKOnly, "Error") = vbCancel Then GoTo PP
        Dir1.Path = "C:\"
    End If
'return default to cmdOk
    cmdOk.Default = True
'set focus on file1
    File1.SetFocus
End Sub




Private Sub Dir1_Change()
'Set the FileListBox Path equal to the DirListBox
    File1.Path = Dir1.Path
'Clear image preview when directory changes
    Image2.Picture = imgBlank.Picture
End Sub

Private Sub Drive1_Change()
    On Error Resume Next
RR:
'Set the DirListBox Path equal to the DriveListBox
'selected drive
    Dir1.Path = UCase(Drive1.Drive)
'Error 68 ocurrs when there is an error with access to
'the Drive
    If Err.Number = 68 Then
        Err.Clear
'Check if the user want's to retry
        If MsgBox("The drive " & Drive1.Drive & " is not ready! Try again?", _
            vbApplicationModal + vbExclamation + vbYesNo, "Error") = vbYes _
                Then GoTo RR
'Else set the Drive to the default C: drive
        Drive1.Drive = "C:\"
    End If
End Sub

Private Sub File1_Click()
    On Error Resume Next
'check for \ in end of path
    If Right(File1.Path, 1) = "\" Then
        strFile = File1.Path
    Else
        strFile = File1.Path & "\"
    End If
'show preview of image
    Image2.Picture = LoadPicture(strFile & File1.FileName)
End Sub

Private Sub File1_GotFocus()
'default ok
    cmdOk.Default = True
End Sub

Private Sub Form_KeyPress(KeyAscii As Integer)
'hide picture box if key is d
    
        
    If KeyAscii = 39 Then
        If Image2.Visible = True Then
            Image2.Visible = False
        ElseIf Image2.Visible = False Then
            Image2.Visible = True
        End If
    End If
    'If KeyAscii = 115 Or KeyAscii = 83 Then Image2.Visible = True

End Sub

Private Sub txtPath_GotFocus()
'set the defaul on cmdGo
    cmdGo.Default = True
End Sub
